/* 
foo_sync 0.1
Copyright (C) 2009  Denis Egea

    This program is free software: you can redistribute it and/or modify
    it under the terms of the Lesser GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the Lesser GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <ATLHelpers/ATLHelpers.h>
#include "resource.h"
#include <Windowsx.h>
#include <iostream>

class my_preferences_page : public preferences_page, public ATL::CAxDialogImpl<my_preferences_page>
{
	public:
		HWND create(HWND parent);
		const char * get_name();
		GUID get_guid();
		GUID get_parent_guid();
		void reset();
		bool reset_query();

	    
		

		static BOOL CALLBACK my_preferences_page::ConfigProc(HWND wnd, UINT msg, WPARAM wp, LPARAM lp)
		{
			switch (msg)
			{
				case WM_INITDIALOG:
				{
					uSetDlgItemText(wnd, IDC_USBPATH,g_usb_sync_path );
				}
				break;

				case WM_COMMAND:
				{
					uGetDlgItemText(wnd, IDC_USBPATH,g_usb_sync_path);
					break;
				}
				
				default:
					return FALSE;
			}
			return TRUE;
		};

		
	
	const char*  get_usb_sync_path() const;
	enum { IDD = IDD_FOOSYNC }; 
	
	static const GUID guid_usb_sync_path;
	static cfg_string g_usb_sync_path;
	static const GUID guid_my_preferences_page;
	};

static preferences_page_factory_t<my_preferences_page> g_my_preferences_page;