/* 
foo_sync 0.1
Copyright (C) 2009  Denis Egea

    This program is free software: you can redistribute it and/or modify
    it under the terms of the Lesser GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the Lesser GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <ATLHelpers/ATLHelpers.h>
#include "resource.h"
#include <Windowsx.h>
#include <Windows.h>
#include <iostream>
#include "config.h"
#include <string>

DECLARE_COMPONENT_VERSION("FooSync", "0.1", NULL);
const GUID myguid={ 0x2D532D05, 0xD1BA, 0x4355, { 0xA0, 0xB9, 0x88, 0x4A, 0x96, 0xEA, 0x54, 0xF6 } };

void send_to_usb( const pfc::list_base_const_t<metadb_handle_ptr> & p_data )
{
	console::printf("[FooSync] Starting copy to USB device\n");
	if (my_preferences_page::g_usb_sync_path=="")
	{	console::printf("[FooSync] Error : no USB device path has been defined. Please go to preferences->tools->FooSync and write the path to the desired folder on your USB device\n");
		return;
	}
	
	pfc::string_fixed_t<255>  sub_path;
	unsigned int i;
	static_api_ptr_t<library_manager> libPtr;
	SHFILEOPSTRUCT sf;
	memset(&sf,0,sizeof(sf));
	sf.hwnd = 0;
	sf.wFunc = FO_COPY;
	sf.fFlags = FOF_NOCONFIRMATION | FOF_NOCONFIRMMKDIR | FOF_NOERRORUI;

	for (i=0;i<p_data.get_size();i++)
	{
		if (libPtr->get_relative_path(p_data[i], sub_path))
		{
			WCHAR    pFrom[255];
			WCHAR    pTo[255];
			memset(pFrom, 0, sizeof(pFrom));
			memset(pTo, 0, sizeof(pTo));
			
			

			MultiByteToWideChar( CP_UTF8,0, p_data[i]->get_path()+7, -1, pFrom, 255);
			sf.pFrom = pFrom;
			
			MultiByteToWideChar( CP_UTF8,0,(std::string(my_preferences_page::g_usb_sync_path) + "\\"+std::string(sub_path)).c_str(), -1, pTo, 255);
			sf.pTo=pTo;
			
			int n = SHFileOperation(&sf);
			if (n==0)
			{
				console::printf("[FooSync] Success\n");
			}
			else
			{
				console::printf("[FooSync] Error copying %s to %s. Error code %i\n",pFrom,pTo,n);
			}

		}
		else
		{
			console::printf("[FooSync] Error : The file %s is not in the media library. File has been ignored ",p_data[i]);
		}
	}
	
	console::printf("[FooSync] Done.\n");
  return;
}

DECLARE_CONTEXT_MENU_ITEM (foosync_SendToUsb_menuitem, // Class Name
                            "Send to USB", // Menu Item Text
                            "FooSync", // Default Path (Group)
                            send_to_usb, // Your Function
                            myguid, // Your GUID
                            "Sends the selection to foo_sync's usb drive" // as it says
							)

